<?php
/****************************************************************************
-----------------------------------------------------------------------------
 *  File            :     Service.php
 *  Subpackage      :     WSPlugin
 *  Packahe         :     Ebizon
 *  Description     :     It provides web services which is requested from IndexController.php
 *  File URL        :     http://192.168.1.101/magento/app/code/local/Ebizon/WSPlugin/controllers 
 *  Developer       :     Shashi Badhuk
 *  Team Lead       :     Shashank Singh
 *  Project Manager :     Utkarsh Srivastava
 *  CEO             :     Sudeep Goyal
 *  Organization    :     Ebizon Net Info Pvt Ltd 
 *  Org URL         :     http://www.ebizontek.com
-----------------------------------------------------------------------------
 *****************************************************************************/

class Service {
    /*====================      Service to fetch all category    =================*/
    public function ws_category($store, $service) {
           $res=array();try {
           $storecategoryid = Mage::app()->getStore($store)->getRootCategoryId();
           $total = 0;
           
                   
                $category = Mage::getModel('catalog/category'); 
                $tree = $category->getTreeModel(); 
                $tree->load();

                $ids = $tree->getCollection()->getAllIds(); 
                $arr = array();

                $storecategoryid = Mage::app()->getStore($store)->getRootCategoryId();
                $cat = Mage::getModel('catalog/category'); 
		        $cat->load($storecategoryid); 
		        $categories = $cat->getCollection()
				  ->addAttributeToSelect(array('name', 'image', 'description','store'))
				  ->addIdFilter($cat->getChildren());
                foreach($categories as $tmp){
					
                     $res[] = array(
                               "id" => $tmp->getId(),
                               "name" => $tmp->getName()
                               );
                     $total=$total+1;
		}                        
		
		array_push($arr, $cat); 
              //  $res = $res + '<br><br><br><center><b>Total Category : '.$total.'</b></center><br>';
           }
           catch(Exception $ex) {
                //$res = $res + 'Exception Problem : '.$ex;
           } 
           return($res);
    }
    public function ws_subcategory($store_id, $service, $categoryid) {
          Mage::app()->setCurrentStore($store_id);
          $res=array();
          $children = Mage::getModel('catalog/category')->getCategories($categoryid);
          foreach ($children as $category) {
			  $res[] = array(
                               "id" => $category->getId(),
                               "name" => $category->getName()
                               );
          }
          return($res);
    }
    public function ws_products($store_id, $service, $categoryid) {
          $res=array();
          Mage::app()->setCurrentStore($store_id); 
	  $c_id = $categoryid;
	  $category = new Mage_Catalog_Model_Category();
	  $category->load($c_id);
	  $collection = $category->getProductCollection()->addStoreFilter($store_id);
	  $collection->addAttributeToSelect('*');
                 
          foreach ($collection as $_product) {
		      //var_dump($_product); die;
                      $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                               "imageurl" => Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$_product->getImage(),
                               "sku" => $_product->getSku(),
                               "spclprice" => number_format($_product->getSpecialprice(),2),
                               "price" => number_format($_product->getPrice(),2),
                               "created_date" => $_product->getCreatedAt(),
                               "is_in_stock" => $_product->getStockItem()->getIsInStock(),
                               "stock_quantity" => Mage::getModel('cataloginventory/stock_item')->loadByProduct($_product->getId())->getQty()
                               ); 
	   } 
	   return($res); 
    }
        
    public function ws_getCustomerId($store, $service, $email) {
         $customer = Mage::getModel('customer/customer');
         $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
         if ($store) {
               $customer->setCurrentStore($store);
               $customer->website_id = $websiteId;
         }
         $customer->loadByEmail($email);
         if ($customer->getId()) {
              $res = array();
              $res["id"] = $customer->getId();
              return $res;
         }
              return -1;
    }
    public function ws_verifyLogin($store, $service, $username, $password) {
        $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
        $res = array();
        $res["username"] = $username;
        $res["password"] = $password;
        $login_status = 1; 
        try{
	     $login_customer_result = Mage::getModel('customer/customer')->setWebsiteId($websiteId)->authenticate($username, $password);
             $login_customer = Mage::getModel('customer/customer')->setWebsiteId($websiteId);
             $login_customer->loadByEmail($username);             
             $res["firstname"] = $login_customer->firstname;
             $res["lastname"] = $login_customer->lastname;
             $res["id"] = $login_customer->getId(); 
             //$res["password"]
             //$res["password"]
        }
        catch( Exception $e ){
             $login_status = 0;
        }
        $res["login_status"] = $login_status;
        return $res;
    }
    public function ws_createuser($store, $service, $firstname, $lastname, $email, $password) {
        // Website and Store details
        $res = array();
		$websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId(); 
		$customer = Mage::getModel("customer/customer");
		$customer->website_id = $websiteId;
		$customer->setCurrentStore($store);
              //  echo 'Phase 2';
		try {
		    // If new, save customer information
		    $customer->firstname = $firstname;
		    $customer->lastname = $lastname;
		    $customer->email = $email;
		    $customer->password_hash = md5($password);
		        $res["email"] =$email;
		        $res["firstname"] =$firstname;
		        $res["lastname"] =$lastname;
		        $res["password"] =$password;
		        $res["status"] = 0;
                $res["id"] = 0;

		    //echo 'Phase 2.5';
		    if($customer->save()){
                $customer->sendNewAccountEmail('confirmed');
                $this->send_Password_Mail_to_NewUser($firstname, $password, $email);
                $res["id"] = $customer->getId();
		        $res["status"] = 1;
                               
		    }
		    else{
                       //echo "Already Exist";
		        $exist_customer = Mage::getModel("customer/customer");
                        $exist_customer->setWebsiteId($websiteId);
                        
                        $exist_customer->setCurrentStore($store);
                        $exist_customer->loadByEmail($email);
                       
                        $res["id"] = $exist_customer->getId();
                        $res["status"] = 1;
                         

	    //echo "An error occured while saving customer";
		    }
            //echo 'Phase 3';
		}catch(Exception $e){
		
                    //echo "Already Exist Exception";
                      try {
                        $exist_customer = Mage::getModel("customer/customer");
                        $exist_customer->setWebsiteId($websiteId);

                        $exist_customer->setCurrentStore($store);
                        $exist_customer->loadByEmail($email);

                        $res["id"] = $exist_customer->getId();
                        $res["status"] = 1;
                       }
                      catch(Exception $ex) {
                        $res["id"] = -1;
                        $res["status"] = 0;
                     }	
		}
		return $res;
     }
     public function ws_productdetail($store_id, $service, $productid) {
		 
          $res=array();
          
		 $productsCollection = Mage::getModel('catalog/product')
                                     ->getCollection()
                                     ->addAttributeToFilter('entity_id', array('in' => $productid))
                                     ->addAttributeToSelect('*');


           $all_product_images = array();
            $product = Mage::getModel('catalog/product')->load($productid);
                foreach ($product->getMediaGalleryImages() as $image) {
                    $all_product_images[] = $image->getUrl();
                 }

foreach($productsCollection as $product) {
                  $res["id"] = $product->getId();
		  $res["sku"] = $product->getSku();
		  $res["name"] = $product->getName();
		  $res["category"] = $product->getCategoryIds(); //'category';
		  $res["image"] = $all_product_images; // Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$product->getImage();
		  $res["url"] = $product->getProductUrl();
		  $res["description"] = $product->getDescription();
		  $res["shortdes"] = $product->getShortDescription();		  
		  $res["quantity"] = Mage::getModel('cataloginventory/stock_item')->loadByProduct($productid)->getQty();//$product->getQty(); 
		  $res["visibility"] = $product->isVisibleInSiteVisibility();//getVisibility(); 
		  $res["type"] = $product->getTypeID();
		  $res["weight"] = $product->getWeight();
		  $res["status"] = $product->getStatus(); 
		  $res["price"] = number_format($product->getPrice(),2);
		  $res["discount"] = number_format($product->getFinalPrice(),2); //getDiscount();
		  $res["shipping"] = Mage::getStoreConfig('carriers/flatrate/price'); //$quote->getShippingAddress()->getShippingRatesCollection(); //$product->getShippingAmount();
		  $res["sprice"] = number_format($product->getSpecialprice(),2);
         }
		return($res); 
    }
    public function ws_productSearchHelp($store_id) {
          $res = array();
          try {
              $collection = Mage::getResourceModel('catalog/product_collection')
                            ->addAttributeToSelect('*')
                            ->addStoreFilter($store_id)
                            ->load();
              $collection->addAttributeToSelect('*');
              foreach ($collection as $_product) {
                      $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                      );
              }
          }
          catch(Exception $ex) {
              $res = $ex->getMessage();
          }  
          return($res);

    }
     public function ws_currency ($store_id, $service) {
		  $res=array();
          $res["currentcurrency"] = Mage::app()->getStore($storeID)->getCurrentCurrencyCode();
          $res["basecurrency"] = Mage::app()->getStore($storeID)->getBaseCurrencyCode();
          $res["currentsymbol"] = Mage::app()->getLocale()->currency($res["currentcurrency"])->getSymbol();
          $res["basesymbol"] = Mage::app()->getLocale()->currency($res["basecurrency"])->getSymbol();
          return($res);
    }
    public function ws_createorder($storeId, $service, $custid, $pmethod, $transid, $Jproduct,$shippCharge) {
          
          $orderproduct = json_decode($Jproduct);
          //var_dump($Jproduct);
          $orderproductid = $orderproduct->id;
          $orderproductqty = $orderproduct->qty;
          //var_dump($orderproductid); 
          //var_dump($orderproductqty);
          
          //die;
          $id=$custid; // get Customer Id
         
          $customer = Mage::getModel('customer/customer')->load($id);

          $transaction = Mage::getModel('core/resource_transaction');
          $storeId = $customer->getStoreId();
          $reservedOrderId = Mage::getSingleton('eav/config')->getEntityType('order')->fetchNewIncrementId($storeId);

			$order = Mage::getModel('sales/order')
			->setIncrementId($reservedOrderId)
			->setStoreId($storeId)
			->setQuoteId(0)
			->setGlobal_currency_code('USD')
			->setBase_currency_code('USD')
			->setStore_currency_code('USD')
			->setOrder_currency_code('USD');

				// set Customer data
				$order->setCustomer_email($customer->getEmail())
				->setCustomerFirstname($customer->getFirstname())
				->setCustomerLastname($customer->getLastname())
				->setCustomerGroupId($customer->getGroupId())
				->setCustomer_is_guest(0)
				->setCustomer($customer);

			// set Billing Address
				$billing = $customer->getDefaultBillingAddress();
				$billingAddress = Mage::getModel('sales/order_address')
				->setStoreId($storeId)
				->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_BILLING)
				->setCustomerId($customer->getId())
				->setCustomerAddressId($customer->getDefaultBilling())
				->setCustomer_address_id($billing->getEntityId())
				->setPrefix($billing->getPrefix())
				->setFirstname($billing->getFirstname())
				->setMiddlename($billing->getMiddlename())
				->setLastname($billing->getLastname())
				->setSuffix($billing->getSuffix())
				->setCompany($billing->getCompany())
				->setStreet($billing->getStreet())
				->setCity($billing->getCity())
				->setCountry_id($billing->getCountryId())
				->setRegion($billing->getRegion())
				->setRegion_id($billing->getRegionId())
				->setPostcode($billing->getPostcode())
				->setTelephone($billing->getTelephone())
				->setFax($billing->getFax());
				$order->setBillingAddress($billingAddress);

				$shipping = $customer->getDefaultShippingAddress();
				$shippingAddress = Mage::getModel('sales/order_address')
				->setStoreId($storeId)
				->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_SHIPPING)
				->setCustomerId($customer->getId())
				->setCustomerAddressId($customer->getDefaultShipping())
				->setCustomer_address_id($shipping->getEntityId())
				->setPrefix($shipping->getPrefix())
				->setFirstname($shipping->getFirstname())
				->setMiddlename($shipping->getMiddlename())
				->setLastname($shipping->getLastname())
				->setSuffix($shipping->getSuffix())
				->setCompany($shipping->getCompany())
				->setStreet($shipping->getStreet())
				->setCity($shipping->getCity())
				->setCountry_id($shipping->getCountryId())
				->setRegion($shipping->getRegion())
				->setRegion_id($shipping->getRegionId())
				->setPostcode($shipping->getPostcode())
				->setTelephone($shipping->getTelephone())
				->setFax($shipping->getFax());
                                //$order->collectShippingRates();
                                if($shippCharge==null || $shippCharge == "")
                                   $shippCharge=0;
				$ShippMessage = 'Order Placed From Mobile and Shipping Method Flatrate. Total Shipping Charge : ';
                                $order->setShippingAddress($shippingAddress)
				->setShipping_method('flatrate_flatrate')
                                ->setCollectShippingRates(true)
				->setShippingDescription($ShippMessage)
                                ->setFinalPriceWithHandlingFee($shippCharge)
                                ->setShippingAmount($shippCharge)
                                ->setBaseShippingAmount($shippCharge);
                                //Mage::getStoreConfig('carriers/flatrate/price');
                                // $order->setShippingAmount($shippCharge);
                                // $order->setBaseShippingAmount($shippCharge);
                if($pmethod == 'cashondelivery' || $pmethod == 'secureebs_standard' || $pmethod == 'authorizenet_directpost' ||$pmethod == 'checkmo' ) {
				     $orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setMethod($pmethod);
			    }
			    elseif($pmethod == 'paypal_standard') {
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setLastTransId($transid)
				       ->setMethod($pmethod);
				       
				}
			    elseif($pmethod == 'purchaseorder') {
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setPo_number($transid)
				       ->setMethod($pmethod);
			    }
			    else {
					//OTHER or UNKNOWN
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId(0)
				       ->setMethod($pmethod);
			    }

                               // $orderPayment->setShippingAmount($shippCharge);
                                //$orderPayment->setBaseShippingAmount($shippCharge);
				$order->setPayment($orderPayment);

				// let say, we have 2 products
				$subTotal = 0;
				
				$ind = 0;
				foreach($orderproductid as $poid) {
					$products[$poid] = array('qty'=> $orderproductqty[$ind]);
					$ind++;
			     }
				
				foreach ($products as $productId=>$product) {
				$_product = Mage::getModel('catalog/product')->load($productId);
				$rowTotal = $_product->getPrice() * $product['qty'];
				$orderItem = Mage::getModel('sales/order_item')
				->setStoreId($storeId)
				->setQuoteItemId(0)
				->setQuoteParentItemId(NULL)
				->setProductId($productId)
				->setProductType($_product->getTypeId())
				->setQtyBackordered(NULL)
				->setTotalQtyOrdered($product['rqty'])
				->setQtyOrdered($product['qty'])
				->setName($_product->getName())
				->setSku($_product->getSku())
				->setPrice($_product->getPrice())
				->setBasePrice($_product->getPrice())
				->setOriginalPrice($_product->getPrice())
				->setRowTotal($rowTotal)
				->setBaseRowTotal($rowTotal);
			        	
				//Update new quantity
				$newqty = (int)(Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId)->getQty())-(int)$product['qty'];
				Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId)->setQty($newqty)->save();
                
                                $subTotal += $rowTotal;
				$order->addItem($orderItem);
				}

				$order->setSubtotal($subTotal)
				->setBaseSubtotal($subTotal)
				->setGrandTotal($subTotal+$shippCharge)
				->setBaseGrandTotal($subTotal+$shippCharge);
                                
				try {
                                $order->getPayment()->setIsTransactionClosed(1);
                                $order->getPayment()->setTransactionAdditionalInfo(Mage_Sales_Model_Order_Payment_Transaction::RAW_DETAILS,array('TransactionID'=>$transid,'key2'=>'value2')); 
				$order->setTransId($transid);
				$transaction->addObject($order);
				$transaction->addCommitCallback(array($order, 'place'));
				$transaction->addCommitCallback(array($order, 'save'));
				$transaction->save();
			    }
			    catch(Exception $ex) {
					echo $ex;
				}
				//$order->setFinalPriceWithHandlingFee($shippCharge);
                                $order->sendNewOrderEmail();
                                $order->getPayment()->setTransactionId($transid);
                                $res=array();
                                $res["id"] = $order->getId();
                                $res["orderid"] = $order->getIncrementId();
				$res["transid"] = $order->getPayment()->getTransactionId();
				return $res;
	}	
    public function ws_setaddress($store, $service, $customerId, $JbillAdd, $JshippAdd) {
	       //----------------------------------------------------------------------
	       $billAdd = json_decode($JbillAdd);
	       $shippAdd = json_decode($JshippAdd);
	       //var_dump($billAdd); 
	       //var_dump($shippAdd); die;
	       $result = array();
	       $result['billaddress'] = 0;
           $result['shippaddress'] = 0; 
          $_bill_address = array (
                 'firstname' => $billAdd->billfname,
                 'lastname' => $billAdd->billlname,
                 'street' => array (
                      '0' => $billAdd->billstreet1,
                      '1' => $billAdd->billstreet2,
                  ),
                  'city' => $billAdd->billcity,
                  'region_id' => '',
                  'region' => $billAdd->billstate,
                  'postcode' => $billAdd->billpostcode,
                  'country_id' => $billAdd->billcountry, 
                  'telephone' => $billAdd->billphone,
          );
          $_shipp_address = array (
                 'firstname' => $shippAdd->shippfname,
                 'lastname' => $shippAdd->shipplname,
                 'street' => array (
                      '0' => $shippAdd->shippstreet1,
                      '1' => $shippAdd->shippstreet2,
                  ),
                  'city' => $shippAdd->shippcity,
                  'region_id' => '',
                  'region' => $shippAdd->shippstate,
                  'postcode' => $shippAdd->shipppostcode,
                  'country_id' => $shippAdd->shippcountry, 
                  'telephone' => $shippAdd->shippphone,
          );
          $billAddress = Mage::getModel('customer/address');
          $billAddress->setData($_bill_address)
                        ->setCustomerId($customerId)
                        ->setIsDefaultBilling('1')
                        ->setSaveInAddressBook('1');
                        
          $shippAddress = Mage::getModel('customer/address');
          $shippAddress->setData($_shipp_address)
                        ->setCustomerId($customerId)
                        ->setIsDefaultShipping('1')
                        ->setSaveInAddressBook('1');              
                        
          try {
              if($billAddress->save())
                 $result['billaddress'] = 1;
              if($shippAddress->save())
                 $result['shippaddress'] = 1;              
          }
          catch (Exception $ex) {
              //Zend_Debug::dump($ex->getMessage());
          }
          return $result;
         //---------------------------------------------------------------------
    }
     public function ws_storedetails($store, $service) {
		 $res = array();
		 try {
		     $res["store"] = Mage::app()->getStore($store);
		     Mage::app()->setCurrentStore($store);
                     $res["storeid"] = Mage::app()->getStore($store)->getStoreId();
		     $res["storecode"] = Mage::app()->getStore($store)->getCode();
		     $res["storewebid"] = Mage::app()->getStore($store)->getWebsiteId();
		     $res["storename"] = Mage::app()->getStore($store)->getName();
		     $res["storeactive"] = Mage::app()->getStore($store)->getIsActive();
		     $res["rooturl"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB); 		     
		     $res["storeurl"] = Mage::helper('core/url')->getHomeUrl(); 
		     $res["storelogo_alt"] = Mage::getStoreConfig('design/header/logo_alt');//Mage::getLogoSrc();
		     
		     $res["storefrontname"] = Mage::app()->getStore($store)->getFrontendName(); //getLogoSrc()		     
		     $res["current_url"] = Mage::helper('core/url')->getCurrentUrl();
             $res["media_url1"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK);
			 $res["media_url2"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA);
			 $res["skin_url"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN);
			 $res["js_url"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_JS);			 
		     $res["storelogo"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN).'frontend/default/default/'.Mage::getStoreConfig('design/header/logo_src');
			 $res["storebanner"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN).'frontend/default/default/images/banner.png';
                         $res["storeadminname"] = Mage::getStoreConfig('trans_email/ident_sales/name');
                         $res["storeemail"] = Mage::getStoreConfig('trans_email/ident_sales/email');			 
		 }
		 catch(Exception $ex) {
			 echo $ex;
		 }
		 return $res;
     }
     public function ws_search($store, $service, $search_data) {
                 
            $res = array();
            try {
                                  
                 // Code to Search Product by $searchstring and get Product IDs
                 $product_collection = Mage::getResourceModel('catalog/product_collection')
                  ->addAttributeToSelect('*')
                  ->addAttributeToFilter('name', array('like' => '%'.$search_data.'%'))
                  ->addStoreFilter($store)
                  ->load();

                 foreach ($product_collection as $_product) {
                 if( $_product->getStoreId() == $store) {
                         $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                               "imageurl" => Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$_product->getImage(),
                               "sku" => $_product->getSku(),
                               "spclprice" => number_format($_product->getSpecialprice(),2),
                               "price" => number_format($_product->getPrice(),2),
                               "created_date" => $_product->getCreatedAt(),
                               "is_in_stock" => $_product->getStockItem()->getIsInStock(),
                               "stock_quantity" => Mage::getModel('cataloginventory/stock_item')->loadByProduct($_product->getId())->getQty()
                               );
                       }
                  }

          }
          catch(Exception $ex) {
                echo $ex;
          }
          return $res;
     }
     public function send_Password_Mail_to_NewUser($user, $pswd, $email) {
           $site =  Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB);
           $mail_link = 'http://125.63.92.59/mail_sender/magento_mail/password_mail.php?username='.$user.'&password='.$pswd.'&site='.$site.'&email='.$email;
           $mail_link = str_replace(" ","%20",$mail_link);
           $ch = curl_init();
           curl_setopt($ch, CURLOPT_URL, $mail_link);
           curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
           //curl_setopt($ch, CURLOPT_PROXY, '192.168.1.11');
           //curl_setopt($ch, CURLOPT_PROXYPORT, '8080');
           curl_setopt($ch, CURLOPT_HEADER, 1);
           $exec = curl_exec($ch);
           curl_close($ch);
    }
    public function ws_myOrder($cust_id) {
           $res = array();
           $orders = Mage::getResourceModel('sales/order_collection')
                     ->addFieldToSelect('*')
                     ->addFieldToFilter('customer_id', $cust_id)
                     ->addFieldToFilter('state', array('in' => Mage::getSingleton('sales/order_config')->getVisibleOnFrontStates()))
                     ->setOrder('created_at', 'desc');   
                    //$this->setOrders($orders); 
           foreach ($orders as $order) {
                $shippingAddress = $order->getShippingAddress();
                $shippadd = array();
                $shippadd = array(
                     "firstname" => $shippingAddress->getFirstname(),
                     "lastname" => $shippingAddress->getLastname(),
                     "company" => $shippingAddress->getCompany(),
                     "street" => $shippingAddress->getStreetFull(),
                     "region" => $shippingAddress->getRegion(),
                     "city" => $shippingAddress->getCity(),
                     "pincode" => $shippingAddress->getPostcode(),
                     "countryid" => $shippingAddress->getCountry_id(),
                     "contactno" => $shippingAddress->getTelephone()
                ); 
                $billingAddress = $order->getBillingAddress();
                $billadd = array();
                $billadd = array(
                     "firstname" => $billingAddress->getFirstname(),
                     "lastname" => $billingAddress->getLastname(),
                     "company" => $billingAddress->getCompany(),
                     "street" => $billingAddress->getStreetFull(),
                     "region" => $billingAddress->getRegion(),
                     "city" => $billingAddress->getCity(),
                     "pincode" => $billingAddress->getPostcode(),
                     "countryid" => $billingAddress->getCountry_id(),
                     "contactno" => $billingAddress->getTelephone()
                );
                $payment = array();
                $payment = $order->getPayment();
                //var_dump($payment); die;
                $payment = array (
                      "payment_method" => $payment->getMethodInstance()->getTitle(), 
                      "payment_method_code" => $payment->getMethodInstance()->getCode()
                );
                //$order = Mage::getModel('sales/order')->load($order_id);
                $items = $order->getAllItems();
                $itemcount=count($items);
                $name=array();
                $unitPrice=array();
                $sku=array();
                $ids=array();
                $qty=array();
                $images = array();
                foreach ($items as $itemId => $item) {
                     $name[] = $item->getName();
                     $unitPrice[]=$item->getPrice();
                     $sku[]=$item->getSku();
                     $ids[]=$item->getProductId();
                     $qty[]=$item->getQtyToInvoice();
                     $products = Mage::getModel('catalog/product')->load($item->getProductId());
                     $images[] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$products->getThumbnail();
                }

                $product = array();
                $product = array (
                     "name" => $name,
                     "sku" => $sku,
                     "id" => $ids,
                     "quantity" => $qty,
                     "unitprice" => $unitPrice,
                     "image" => $images,
                     "total_item_count" => $itemcount
                );
                $order_date = $order->getCreatedAtStoreDate().'';
                $res[] = array(
                     "id" => $order->getId(),
                     "order_id" => $order->getRealOrderId(),
                     "status" => $order->getStatus(),
                     "order_date" => $order_date,
                     "grand_total" => $order->getGrandTotal(),
                     "shipping_address" => $shippadd,
                     "billing_address" => $billadd,
                     "shipping_message" => $order->getShippingDescription(),
                     "shipping_amount" => $order->getShippingAmount(),
                     "payment_method" => $payment,
                     "product" => $product
                );
           }
           return $res;
    }
    public function ws_myProfile($cust_id) {
         try {
              $customer = Mage::getModel('customer/customer')->load($cust_id);
              $customerData = $customer->getData();
              $shippingAddress = $customer->getDefaultShippingAddress();
         }
         catch(Exception $ex2) {
              echo $ex2;
         }
         $shippadd = array();
         $billadd = array();
         try {
              if($shippingAddress!=null) {
                   $shippadd = array(
                       "firstname" => $shippingAddress->getFirstname(),
                       "lastname" => $shippingAddress->getLastname(),
                       "company" => $shippingAddress->getCompany(),
                       "street" => $shippingAddress->getStreetFull(),
                       "region" => $shippingAddress->getRegion(),
                       "city" => $shippingAddress->getCity(),
                       "pincode" => $shippingAddress->getPostcode(),
                       "countryid" => $shippingAddress->getCountry_id(),
                       "contactno" => $shippingAddress->getTelephone()
                   );
              }
              $billingAddress = $customer->getDefaultBillingAddress();
              if($billingAddress!=null){
                   $billadd = array(
                       "firstname" => $billingAddress->getFirstname(),
                       "lastname" => $billingAddress->getLastname(),
                       "company" => $billingAddress->getCompany(),
                       "street" => $billingAddress->getStreetFull(),
                       "region" => $billingAddress->getRegion(),
                       "city" => $billingAddress->getCity(),
                       "pincode" => $billingAddress->getPostcode(),
                       "countryid" => $billingAddress->getCountry_id(),
                       "contactno" => $billingAddress->getTelephone()
                   ); 
              }
         }
         catch(Exception $ex) {
              echo $ex; 
         }
         $res = array();
         $res = array(
              "CustomerInfo" => $customerData,
              "BillingAddress" => $billadd,
              "ShippingAddress" => $shippadd
         );
         return $res;
   }
    public function ws_changeProfilePassword($custid, $username, $oldpassword, $newpassword, $store) {
        $res = array();
        $validate = 0;
        $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
        try {
             $login_customer_result = Mage::getModel('customer/customer')->setWebsiteId($websiteId)->authenticate($username, $oldpassword);
             $validate = 1;
        }
        catch(Exception $ex) {
             $validate = 0;
        }
        if($validate == 1) {
             try {
                  $customer = Mage::getModel('customer/customer')->load($custid);
                  $customer->setPassword($newpassword);
                  $customer->save();    
                  $res = array (
                       "customerid" => $custid,
                       "oldpassword" => $oldpassword,
                       "newpassword" => $newpassword,
                       "change_status" => 1,
                       "message" => 'Your Password has been Changed Successfully'
                  );
             }
             catch(Exception $ex) {
                  $res = array (
                       "customerid" => $custid,
                       "oldpassword" => $oldpassword,
                       "newpassword" => $newpassword,
                       "change_status" => -1,
                       "message" => 'Error : '.$ex->getMessage
                  );
             }
        }
        else {
            $res = array (
                 "customerid" => $custid,
                 "oldpassword" => $oldpassword,
                 "newpassword" => $newpassword,
                 "change_status" => 0,
                 "message" => 'Incorrect Old Password.'
            );
        }
        return $res;
    }
}


